/*
*  ALCATEL SpeedTouch USB modem block extract utility
*  Copyright (C) 2001 Benoit PAPILLAULT
*  
*  This program is free software; you can redistribute it and/or
*  modify it under the terms of the GNU General Public License
*  as published by the Free Software Foundation; either version 2
*  of the License, or (at your option) any later version.
*  
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*  Author   : Benoit PAPILLAULT <benoit.papillault@free.fr>
*  Creation : 25/04/2001
*  Refactor : Matthew Gream (matthew.gream@pobox.com)
*
* $Id: extract.h,v 1.4 2003/11/23 22:26:15 matt Exp $
*/

#ifndef _EXTRACT_H_
#define _EXTRACT_H_


#define TOKEN_LENGTH_MAX	32

struct extract_block_config
{
	const char*		description;
	const unsigned char 	start_tokens[TOKEN_LENGTH_MAX];
	int 			start_length;
	const unsigned char	final_tokens[TOKEN_LENGTH_MAX];
	int			final_length;
	unsigned int		length;
	unsigned int		signature;
};


extern unsigned char * extract_block(const struct extract_block_config* config, const char *file, long * size);

#endif
