/*
*  ALCATEL SpeedTouch USB modem utility : PPPoA implementation (3nd edition)
*  Copyright (C) 2001 Edouard Gomez
* 
*  This program is free software; you can redistribute it and/or
*  modify it under the terms of the GNU General Public License
*  as published by the Free Software Foundation; either version 2
*  of the License, or (at your option) any later version.
*  
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*  Author : Edouard Gomez (ed.gomez@free.fr)
*  Creation : 08/08/2001
*  Refactor : Matthew Gream (matthew.gream@pobox.com)
*
* $Id: product-conexant.h,v 1.1 2003/11/23 22:26:15 matt Exp $
*/

#ifndef _PRODUCT_CONEXANT_H_
#define _PRODUCT_CONEXANT_H_


/******************************************************************************
* Interface
******************************************************************************/

extern int product_conexant_usage (void);
extern int product_conexant_options_parse (int argc, char** argv, int* argi);
extern int product_conexant_options_check (void);

extern int product_conexant_acquire (pusb_device_t h, product_acquire_t q);
extern int product_conexant_release (pusb_device_t h, product_acquire_t q);

extern int product_conexant_configure_check (pusb_device_t h);
extern int product_conexant_configure_load (pusb_device_t h);
extern int product_conexant_configure_report (pusb_device_t h);
extern int product_conexant_configure_wait (pusb_device_t h);
extern int product_conexant_configure_config (pusb_device_t h);

extern int product_conexant_connect_setup (pusb_device_t h);
extern int product_conexant_connect_verify (pusb_device_t h);
extern int product_conexant_connect_start (pusb_device_t h);
extern int product_conexant_connect_stop (pusb_device_t h);
extern int product_conexant_connect_check_wait (pusb_device_t h);
extern int product_conexant_connect_check_line (pusb_device_t h);
extern int product_conexant_connect_check_data (pusb_device_t h, int timeout);
extern int product_conexant_connect_report (pusb_device_t h);
extern int product_conexant_disconnect_wait (pusb_device_t h);
extern int product_conexant_disconnect_check_line (pusb_device_t h);

extern int product_conexant_data_write (pusb_device_t h, const unsigned char* buffer_ptr, int buffer_sz, int timeout);
extern int product_conexant_data_read (pusb_device_t h, unsigned char* buffer_ptr, int buffer_sz, int timeout);
extern int product_conexant_data_report (pusb_device_t h);


#endif

